<?php
namespace DatabaseHelper\enums;

enum Charset
{
    case UTF8;
    case UTF8MB4;
    case LATIN1;
    case ASCII;
    case UTF16;
    case UTF32;
    case LATIN2;
    case LATIN5;
    case CP1251;
    case CP850;
    case TIS620;
    case GREEK;
    case HEBREW;
    case BINARY;

    public function toString(): string {
        return match ($this) {
            self::UTF8 => 'utf8',
            self::UTF8MB4 => 'utf8mb4',
            self::LATIN1 => 'latin1',
            self::ASCII => 'ascii',
            self::UTF16 => 'utf16',
            self::UTF32 => 'utf32',
            self::LATIN2 => 'latin2',
            self::LATIN5 => 'latin5',
            self::CP1251 => 'cp1251',
            self::CP850 => 'cp850',
            self::TIS620 => 'tis620',
            self::GREEK => 'greek',
            self::HEBREW => 'hebrew',
            self::BINARY => 'binary',
        };
    }
}

